
////////////////////////////////////////////////////////////////////
// tda bufferu logickch hodnot

////////////////////////////////////////////////////////////////////
// Poznmka - pi kopii a pesunu struktur se vytv nov poloky,
//            star se nechaj se na mst.
////////////////////////////////////////////////////////////////////

class CBoolBuf : public CObject
{
public:
// konstruktor a destruktor
	CBoolBuf();
	~CBoolBuf();

// data
	char* m_pData;			// ukazatel na data
	int m_nSize;				// poet prvk
	int m_nMaxSize;				// maximln velikost bufferu

// zjitn potu poloek v bufferu
	inline int GetSize() const 
		{ return m_nSize; }

// nastaven nov velikosti bufferu
	void SetSize(int nNewSize);

// poskytnut poloky na dan pozici
	inline char Get(int nIndex) const
		{ 
			if (nIndex < 0 || nIndex >= m_nSize)
				return 0;
			else
				return m_pData[nIndex]; 
		}

// nastaven poloky na dan pozici
	inline void Set(int nIndex, char newElement)
		{
			if (nIndex >= 0 && nIndex < m_nSize)
			{
				if (newElement == 0)
					m_pData[nIndex] = 0;
				else
					m_pData[nIndex] = -1;
			}
		}

// pstup k poloce pole
	inline char& operator[] (int nIndex)
		{ 
			ASSERT(nIndex >= 0 && nIndex < m_nSize);
			return m_pData[nIndex]; 
		}

// pidn poloky na konec pole
	inline int Add(char newElement)
		{
			SetSize(m_nSize+1);
			if (newElement == 0)
				m_pData[m_nSize-1] = 0;
			else
				m_pData[m_nSize-1] = -1;
			return m_nSize-1;
		}

// vyprzdnn celho bufferu
	inline void RemoveAll() { SetSize(0); }

// zruen poloky s danm indexem (implicitn 1 poloka)
	void Delete(int nIndex, int nCount = 1);
};
