
////////////////////////////////////////////////////////////////////
// tda bufferu ikon

class CIconBuf : public CObject
{
// konstruktor a destruktor
public:
	CIconBuf();					// konstruktor
	virtual ~CIconBuf();		// destruktor

// ukazatele bufferu
	unsigned char*	m_Data;		// data ikon
	int				m_Num;		// poet ikon v bufferu
	int				m_Max;		// velikost bufferu
	int				m_Width;	// ka jedn ikony (bod)
	int				m_Height;	// vka jedn ikony (linek)
	int				m_WidthByte;// dlka jedn linky v bajtech
	int				m_ItemSize;	// velikost jedn ikony v bajtech

	BOOL			m_GenPal;	// pznak vygenerovn palet pro LoadFile

// nastaven nov velikosti bufferu (v potech ikon)
	void SetSize(int NewSize);

// poskytnut potu ikon
	inline int GetSize() const
		{ return m_Num; }

// poskytnut adresy ikony (kontroluje meze - pp. vrac ikonu 0)
	inline unsigned char* Get(int Index) const
	{
		if ((Index <= 0) || (Index >= m_Num))
			return m_Data;
		else
			return &m_Data[m_ItemSize*Index];
	}

// nastaven dat ikony
	inline void Set(int Index, unsigned char* data)
	{
		memcpy(Get(Index), data, m_ItemSize);
	}

// pidn nov ikony (vrac index)
	inline int Add(unsigned char* data)
	{
		SetSize(m_Num+1);		// nastaven nov velikosti bufferu
		Set(m_Num-1, data);		// nastaven dat ikony
		return m_Num-1;			// index nov poloky
	}

// zaloen nov (przdn) ikony (vrac index)
	inline int New()
	{
		SetSize(m_Num+1);		// nastaven nov velikosti bufferu
		memcpy(Get(m_Num-1), m_Data, m_ItemSize);
		return m_Num-1;			// index nov poloky
	}

// duplikace ikony (kontroluje meze - pp. pouije 0, vrac index nov ikony)
	inline int Duplik(int Index)
	{
		SetSize(m_Num+1);		// nastaven nov velikosti bufferu
		Set(m_Num-1, Get(Index)); // nastaven dat ikony
		return m_Num-1;			// index nov poloky
	}

// vprzdnn celho bufferu
	inline void RemoveAll() { m_Num = 0; }

// zruen poloky (implicitn 1 poloka)
	void Delete(int Index, int Count = 1);

// naten ikon z resource
	void LoadRes(int id);

// naten ikony ze souboru (vrac index ikony)
	int LoadFile(CString name);

// vygenerovn dat bitmapy (vrac ukazatel na data vytvoen pomoc Aloc)
// barevn bitmapa m na konci rezervu pro zarovnn linky na 8 bajt
	unsigned char* GenerBitmap();

// vygenerovn masky z barevn bitmapy (vrac ukazatel na data pomoc Aloc)
// barevn bitmapa mus mt na konci rezervu pro zarovnn linky na 8 bajt
	unsigned char* GenerMask(unsigned char* bitmapa);

// vygenerovn seznamu ikon (vrac ukazatel na seznam ikon)
	CImageList* GenerList();
};
