
/////////////////////////////////////////////////////////////////////////////
//																		   //
//							obsluha navigace							   //
//																		   //
/////////////////////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////////////////////////
// aktualizace ukazatele potu referenc

void CProg::OnUpdateProgRefer(CCmdUI* pCmdUI) 
{
// lokln promnn, nalezen aktulnho prvku
	short bufID = m_AktBufID;					// slo aktulnho bufferu
	CProgBuf* buf = &(m_Buf[bufID]);			// aktuln buffer
	HTREEITEM htree = buf->m_Tree->GetSelectedItem(); // nalezen aktivnho prvku
	int itemN = buf->SrcItem(htree);			// nalezen indexu aktivnho prvku
	PROGITEM* item;								// ukazatel na prvek
	CStatic* txt;								// prvek zobrazenho textu
	TCHAR buff[10];								// buffer k dekdovn textu sla
	short count;								// poet referenc

// test, zda byl prvek nalezen
	if (itemN != -1)							// pokud je vybrn njak prvek
	{

// ukazatel na aktuln prvek
		item = &(buf->m_Items[itemN]);			// ukazatel na prvek

// pesmrovn na deklaran poloku prvku
		if  (
			 (
			  ((bufID == BufEdiID) && (item->typ != -1))	// z editoru vdy do jinho bufferu
			  ||
			  ((bufID != BufEdiID) && (item->typ == BufStrID)) // z jinch buffer jen do struktur
			 ) 
			 && 
			 (item->refer != -1)				// platn ukazatel reference
			)
			item = &(m_Buf[item->typ].m_Items[item->refer]); // pesmrovn na deklaran prvek

// poet referenc prvku
		count = item->counter;					// poet referenc prvku

// test, zda byl daj potu referenc zmnn
		if (count != m_OldRef)					// zmnil se poet referenc ?
		{
// zobrazen novho potu referenc
			wsprintf(buff, _T("%d"), count);	// pprava sla k zobrazen
			txt = (CStatic*)(MainFrame->		// nalezen okna textu
				m_wndNavBar.GetDlgItem(IDC_PROG_REFER));
			if (txt != NULL)					// bylo okno nalezeno ?
			{
				txt->SetWindowText(buff);		// nastaven textu potu referenc
				m_OldRef = count;				// schova novho potu referenc
			}
			else
				m_OldRef = -2;					// jinak poet referenc neplatn
		}
	}

// jinak se text potu referenc vymae
	else
	{
		if (m_OldRef != -1)						// je text potu referenc vymazn ?
		{
			txt = (CStatic*)(MainFrame->		// nalezen okna textu
				m_wndNavBar.GetDlgItem(IDC_PROG_REFER));
			if (txt != NULL)					// bylo okno nalezeno ?
			{
				txt->SetWindowText(_T(""));		// vymazn potu referenc
				m_OldRef = -1;					// pznak vymazn textu referenc
			}
			else
				m_OldRef = -2;					// jinak poet referenc neplatn
		}
	}
}


/////////////////////////////////////////////////////////////////////////////
// zadn textu k hledn

void CProg::OnChangeFind() 
{
// pprava editoru textu
	CEdit* name = (CEdit*)(MainFrame->m_wndNavBar.GetDlgItem(IDC_PROG_FIND));

// naten textu z editoru
	if (name != NULL)
		name->GetWindowText(FindString);		// naten textu do bufferu
}

void CProg::OnProgEdit() 
{
// pprava editoru textu
	CEdit* name = (CEdit*)(MainFrame->m_wndNavBar.GetDlgItem(IDC_PROG_FIND));

// aktivace okna
	if (name != NULL)
		name->SetFocus();						// aktivace okna
}

/////////////////////////////////////////////////////////////////////////////
// nalezen dalho vskytu textu

void CProg::OnFindNext() 
{
	OnFind(1);
}


/////////////////////////////////////////////////////////////////////////////
// nalezen pedelho vskytu textu

void CProg::OnFindPrev() 
{
	OnFind(-1);
}


/////////////////////////////////////////////////////////////////////////////
// nalezen textu v poadovanm smru

void CProg::OnFind(short inc)
{
// lokln promnn
	short bufnum;								// ta buffer k prohledn
	CString txt = _T("");						// buffer textu k poloce
	CString txtfind = FindString;				// hledan text

	short bufID = m_AktBufID;					// slo aktivnho bufferu
	CProgBuf* buf = &(m_Buf[bufID]);			// adresa aktivnho bufferu
	short itemN = buf->SrcItem(buf->m_Tree->GetSelectedItem())+inc; // ukazatel sla aktivnho prvku
	PROGITEM* item;								// ukazatel na prvek
	short num = buf->m_Num;						// poet poloek v bufferu

// pprava hledanho textu
	txtfind.MakeUpper();						// konverze na velk psmena

// cyklus pes vechny buffery (+ 1 na pekryv)
	for (bufnum = 6+1; bufnum > 0; bufnum--)
	{

// cyklus pes vechny poloky v bufferu
		for (; ((itemN < num) && (itemN >= 0)); itemN += inc)
		{

// pprava adresy poloky
			item = &(buf->m_Items[itemN]);		// adresa poloky

// nekontroluje se ROOT poloka LOCAL a EDIT
			if	(
				 ((bufID == BufEdiID) || (bufID == BufLocID)) &&
				 (item->parent == -1)
				)
				continue;						// peskoen kontroly

// naten textu k poloce
			txt = buf->GetName(itemN);			// naten textu jmna k poloce
			txt.MakeUpper();					// konverze na velk psmena

// vyhledn textu k poloce
			if (txt.Find(txtfind) != -1)
			{

// zobrazen clov poloky
				DispItem(bufID, itemN);			// nastaven nalezen poloky
				return;
			}
		}

// posun ukazatele na dal buffer
		if (inc > 0)							// je smr vped ?
		{
			switch(bufID)
			{
				case BufEdiID: bufID = BufStrID; break;
				case BufStrID: bufID = BufClsID; break;
				case BufClsID: bufID = BufLocID; break;
				case BufLocID: bufID = BufObjID; break;
				case BufObjID: bufID = BufEdiID; break;
			}
			buf = &(m_Buf[bufID]);				// adresa bufferu
			itemN = 0;							// ukazatel sla prvku
		}
		else
		{
			switch(bufID)
			{
				case BufEdiID: bufID = BufObjID; break;
				case BufObjID: bufID = BufLocID; break;
				case BufLocID: bufID = BufClsID; break;
				case BufClsID: bufID = BufStrID; break;
				case BufStrID: bufID = BufEdiID; break;
			}
			buf = &(m_Buf[bufID]);				// adresa bufferu
			itemN = buf->m_Num-1;				// ukazatel sla prvku
		}
		num = buf->m_Num;						// poet poloek v bufferu
	}
}


/////////////////////////////////////////////////////////////////////////////
// zobrazen nalezen poloky

void CProg::DispItem(short bufID, short itemN)
{
// lokln promnn
	CProgBuf* buf = &(m_Buf[bufID]);			// adresa bufferu
	short First;								// ROOT poloka
	short itemN2;								// odkazujc poloka

// nalezen ROOT poloky
	First = itemN;
	while (buf->m_Items[First].parent != -1)	// je to ji ROOT ?
		First = buf->m_Items[First].parent;		// pesmrovn na rodie

// je-li editor, nalezen deklaran sti LOKAL
	if (bufID == BufEdiID)
	{
		itemN2 = m_BufLoc.SrcDat(bufID, First);	// nalezen odkazovac poloky
		if (itemN2 != -1)						// byla poloka nalezena ?
			m_BufLoc.SetFirst(itemN2);			// zajitn zobrazen potku
	}

// zajitn zobrazen prvn poloky v aktulnm bufferu
	buf->SetFirst(itemN);						// zajitn zobrazen prvn poloky

// pepnut na clov okno
	buf->m_Tree->SetFocus();					// pepnut na clov okno

// nastaven aktivn poloky
	buf->m_Tree->EnsureVisible(buf->m_Items[itemN].htree);	// zajitn viditelnosti poloky
	buf->m_Tree->SelectItem(buf->m_Items[itemN].htree);	// nastaven poloky jako aktivn

// aktualizace defininch ukazatel
	AktAllDef();								// aktualizace defininch ukazatel
}


/////////////////////////////////////////////////////////////////////////////
// aktualizace vech defininch ukazatel

void CProg::AktAllDef()
{
// lokln promnn
	short itemN;								// ukazatel sla poloky

// nalezen odkazu z loklnho bufferu do editoru
	switch (m_EditBufN)
	{
	case BufPicID:
	case BufMapID:
		itemN = m_BufLoc.SrcDat(m_EditBufN, m_EditItem);
		break;
	default:
		itemN = m_BufLoc.SrcDat(BufEdiID, m_BufEdi.m_First-1);
		break;
	}

// oznaen editovan poloky v loklnch objektech
	if (itemN == -1)							// byla poloka platn ?
		m_BufLoc.SetDef(-1);					// vypnut indiktoru
	else
		if (m_BufLoc.m_Items[itemN].parent == -1) // je to ROOT poloka ?
			m_BufLoc.SetDef(-1);				// pro ROOT poloku nebude ukazatel
		else
			m_BufLoc.SetDef(itemN);				// jinak nastaven ukazatele na poloku

// nalezen odkazu v globlnch objektech
	switch (m_EditBufN)
	{
	case BufPicID:
	case BufMapID:
		itemN = m_BufObj.SrcDat(m_EditBufN, m_EditItem);
		break;
	default:
		itemN = m_BufObj.SrcDat(BufLocID, m_BufLoc.m_First-1); // nalezen odkazu
		break;
	}

	if (itemN == -1)							// byla poloka platn ?
		m_BufObj.SetDef(-1);					// vypnut indiktoru
	else
		m_BufObj.SetDef(itemN);					// nastaven ukazatele na poloku

// nalezen odkazu ve tdch
	itemN = m_BufCls.SrcDat(BufLocID, m_BufLoc.m_First-1); // nalezen odkazu
	if (itemN == -1)							// byla poloka platn ?
		m_BufCls.SetDef(-1);					// vypnut indiktoru
	else
		m_BufCls.SetDef(itemN);					// nastaven ukazatele na poloku
}


/////////////////////////////////////////////////////////////////////////////
// skok na deklaran poloku

void CProg::OnRefDef() 
{
// lokln promnn, nalezen aktulnho prvku
	CProgBuf* buf = &(m_Buf[m_AktBufID]);		// aktuln buffer
	HTREEITEM htree = buf->m_Tree->GetSelectedItem(); // nalezen aktivnho prvku
	short itemN = buf->SrcItem(htree);			// nalezen indexu aktivnho prvku
	PROGITEM* item;								// ukazatel na prvek
	short bufID2;								// eklaran buffer
	short itemN2;								// deklaran poloka

// test, zda byl prvek nalezen
	if (itemN != -1)							// pokud je vybrn njak prvek
	{

// ukazatel na aktuln prvek
		item = &(buf->m_Items[itemN]);			// ukazatel na prvek

// odkaz na deklaran poloku
		bufID2 = item->typ;						// deklaran buffer
		itemN2 = item->refer;					// deklaran poloka

// skok na deklaran poloku, je-li platn
		if (((bufID2 == BufObjID) ||			// globln objekty
			(bufID2 == BufLocID) ||				// lokln objekty
			(bufID2 == BufClsID) ||				// tdy
			(bufID2 == BufStrID)) &&			// struktury
			(itemN2 != -1))						// platn index
		{
			DispItem(bufID2, itemN2);			// skok na deklaraci			
		}
	}
}


/////////////////////////////////////////////////////////////////////////////
// skok na dal pouit poloky

void CProg::OnRefNext() 
{
	OnRefNextPrev(1);
}


/////////////////////////////////////////////////////////////////////////////
// skok na pedel pouit poloky

void CProg::OnRefPrev() 
{
	OnRefNextPrev(-1);
}


/////////////////////////////////////////////////////////////////////////////
// skok na pouit poloky v poadovanm smru

void CProg::OnRefNextPrev(short smer)
{
// lokln promnn
	short bufID = m_AktBufID;					// slo bufferu
	CProgBuf* buf = &(m_Buf[bufID]);			// adresa bufferu
	short itemN;								// ukazatel sla poloky
	PROGITEM* item;								// adresa poloky

// aktuln vybran poloka
	itemN = buf->GetAkt();						// nalezen aktivn poloky
	if (itemN == -1) return;					// nen vybrna dn poloka
	item = &(buf->m_Items[itemN]);				// adresa poloky

// nalezen poloky pro editor
	if (bufID == BufEdiID)
		AktRef(BufEdiID, item->typ, item->refer, smer); // nalezen poloky
	else

// nalezen poloky pro tdy
		if (bufID == BufClsID)
		{
			if (!AktRef(BufLocID, bufID, itemN, smer)) // hledn v loklnm bufferu
			AktRef(BufObjID, bufID, itemN, smer);	// hledn v globlnm bufferu
		}
		else

// pro ostatn buffery zmna na editan buffer
			AktRef(BufEdiID, bufID, itemN, smer);
}


/////////////////////////////////////////////////////////////////////////////
// aktualizace poloky s poadovanou referenc

BOOL CProg::AktRef(short bufID, short bufref, short itemref, short smer)
{
// nalezen poloky v editoru
	short itemN = m_Buf[bufID].SrcRef(bufref, itemref, smer);

// zobrazen nalezen poloky
	if (itemN != -1)							// byla poloka nalezena ?
	{
		DispItem(bufID, itemN);					// zobrazen poloky
		return TRUE;							// pznak zobrazen poloky
	}
	else
		return FALSE;							// pznak nenalezen poloky
}

